﻿#include "define.h"

// INCLUDE
vec4 computePixelColor();
// IN
uniform int bufferSize;

#if multisample
	layout(binding = 0, r32ui) coherent  uniform uimage2DMS	     image_counter;
	layout(binding = 1, rg32f) writeonly uniform  image2DMSArray image_peel;	
#else
	layout(binding = 0, r32ui) coherent  uniform uimage2DRect  image_counter;
	layout(binding = 1, rg32f) writeonly uniform  image2DArray image_peel;
#endif

void main(void)
{
	int   id;
	ivec2 coords = ivec2(gl_FragCoord.xy);
	vec4  value = vec4(packUnorm4x8(computePixelColor().abgr), gl_FragCoord.z, 0.0f, 0.0f);

#if multisample
	id = int(imageAtomicIncWrap (image_counter, coords, gl_SampleID, bufferSize));
	imageStore(image_peel, ivec3(coords, id), gl_SampleID, value);
#else
	id = int(imageAtomicIncWrap (image_counter, coords, bufferSize));
	imageStore(image_peel, ivec3(coords, id), value);
#endif 
}