﻿#include "define.h"

#if multisample
	layout(binding = 0, r32ui) writeonly uniform uimage2DMS   image_next;
	layout(binding = 1, r32ui) writeonly uniform uimage2DMS   image_counter;
#else
	layout(binding = 0, r32ui) writeonly uniform uimage2DRect image_next;
	layout(binding = 1, r32ui) writeonly uniform uimage2DRect image_counter;
#endif 

#if multisample
	void setPixelCurrentPageID(ivec2 coords, uint val){imageStore(image_next   , coords, gl_SampleID, uvec4(val, 0U, 0U, 0U) );}
	void setPixelFragCounter  (ivec2 coords, uint val){imageStore(image_counter, coords, gl_SampleID, uvec4(val, 0U, 0U, 0U) );}
#else
	void setPixelCurrentPageID(ivec2 coords, uint val){imageStore(image_next   , coords, uvec4(val, 0U, 0U, 0U) );}
	void setPixelFragCounter  (ivec2 coords, uint val){imageStore(image_counter, coords, uvec4(val, 0U, 0U, 0U) );}
#endif
	
void main(void)
{
	ivec2 coords = ivec2(gl_FragCoord.xy);
	setPixelCurrentPageID(coords, 0U);
	setPixelFragCounter  (coords, 0U);
}
