﻿#include "define.h"

#if multisample
										 uniform sampler2DMS   tex_counter;
	layout(binding = 0, r32ui) writeonly uniform uimage2DMS    image_counter;
	layout(binding = 1, r32ui) writeonly uniform uimage2DMS    image_next;
#else
										 uniform sampler2DRect tex_counter;
	layout(binding = 0, r32ui) writeonly uniform uimage2DRect  image_counter;
	layout(binding = 1, r32ui) writeonly uniform uimage2DRect  image_next;
#endif 

#if multisample
	uint getPixelCounter	  (ivec2 coords			 ){return uint(texture(tex_counter, coords, gl_SampleID).x);}
	void setPixelCounter      (ivec2 coords, uint val){imageStore(image_counter	 , coords, gl_SampleID, uvec4(val, 0U, 0U, 0U) );}
	void setPixelNextAddress  (ivec2 coords, uint val){imageStore(image_next	 , coords, gl_SampleID, uvec4(val, 0U, 0U, 0U) );}
#else
	uint getPixelCounter	  (ivec2 coords			 ){return uint(texture(tex_counter, coords).x);}
	void setPixelCounter	  (ivec2 coords, uint val){imageStore(image_counter	 , coords, uvec4(val, 0U, 0U, 0U) );}
	void setPixelNextAddress  (ivec2 coords, uint val){imageStore(image_next	 , coords, uvec4(val, 0U, 0U, 0U) );}
#endif
	
void main(void)
{
	ivec2 coords = ivec2 (gl_FragCoord.xy);
#if atomic
	setPixelCounter		 (coords, 0U);
#else
	setPixelCounter		 (coords, getPixelCounter(coords)); 
#endif
	setPixelNextAddress	 (coords, 0U);
}