﻿#include "define.h"

// INCLUDE
	vec4 computePixelColor();
// IN
#if multisample
	layout(binding = 1, r32ui) coherent  uniform uimage2DMS   image_next;
#else
	layout(binding = 1, r32ui) coherent  uniform uimage2DRect image_next;
#endif 
	layout(binding = 2, rg32f) writeonly uniform imageBuffer  image_peel;

#if multisample
	uint addPixelNextAddress  (ivec2 coords, uint val)	{ return imageAtomicAdd	(image_next, coords, gl_SampleID, val);}
#else
	uint addPixelNextAddress  (ivec2 coords, uint val)	{ return imageAtomicAdd	(image_next, coords, val);}
#endif 
	void sharedPoolSetValue	  (uint index  , vec4 val)	{		 imageStore		(image_peel, (int) index, val);}

void main(void)
{
	vec4  value = vec4(packUnorm4x8(computePixelColor().abgr), gl_FragCoord.z, 0.0f, 0.0f);

	ivec2 coords  = ivec2(gl_FragCoord.xy);
	uint  page_id = addPixelNextAddress(coords, 1U);

	sharedPoolSetValue (page_id, value);
}
