﻿#include "define.h"

			 uniform  int  width;
	coherent uniform uint *next_address[COUNTERS];

#if atomic
#if multisample
	layout(binding = 0, r32ui) writeonly uniform uimage2DMS   image_counter;

	void setPixelCounter      (ivec2 coords, uint val)		 {imageStore(image_counter	 , coords, gl_SampleID, uvec4(val, 0U, 0U, 0U) );}
#else
	layout(binding = 0, r32ui) writeonly uniform uimage2DRect image_counter;

	void setPixelCounter	  (ivec2 coords, uint val)		 {imageStore(image_counter	 , coords, uvec4(val, 0U, 0U, 0U) );}
#endif 
#endif 
	void setSharedNextAddress (int j,		 uint val)		 {(*next_address[j]) = val;}
	
void main(void)
{
	ivec2 coords = ivec2 (gl_FragCoord.xy);
#if atomic
	setPixelCounter		 (coords, 0U);
#endif
	int id = int(coords.y);
	if(id < COUNTERS)
		setSharedNextAddress(id, 0U);
}